/* exponential.c - exponentially distributed random numbers
 *
 * Copyright (C) 2001, 2005  Jochen Voss.  */

static const  char  rcsid[] = "$Id: exponential.c 6503 2005-07-05 22:33:38Z voss $";

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <math.h>
#include <assert.h>

#include "jvrand-p.h"


double
jvrand_exponential (double l)
/* Exponentially distributed random numbers with mean 1/l.  */
{
  assert (l>0);
  return  -log(1.0-jvrand_real2())/l;
}
