/* geometric.c - the geometric distribution
 *
 * Copyright (C) 2001  Jochen Voss.  */

static const  char  rcsid[] = "$Id: geometric.c 6503 2005-07-05 22:33:38Z voss $";

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <math.h>
#include <assert.h>

#include "jvrand-p.h"

/* Modell: Let x_n (n>=0) be independent random variables with P(x_n=0) = p
 *   and P(X_n=1) = 1-p =: q.
 * Return X = "the smallest n with x_n=0".
 * Distribution: P(X=n) = p * q^n
 * Expectation: mean = q/p  */


unsigned
jvrand_geometric (double p)
/* Return a random integer, according to the geometric distribution.  */
{
  double  U;
  
  assert (0 < p && p < 1);
  U = jvrand_real2();
  return  (int)(log(1-U)/log(1-p));
}
