/* jvrand-p.h - private header file for the jvrand library
 *
 * Copyright (C) 2001  Jochen Voss.
 *
 * $Id: jvrand-p.h 6503 2005-07-05 22:33:38Z voss $ */

#ifndef FILE_JVRAND_P_H_SEEN
#define FILE_JVRAND_P_H_SEEN

#include "jvrand.h"

#ifdef __GNUC__
#define  NORETURN_FN  __attribute__ ((noreturn))
#else
#define  NORETURN_FN
#endif

/* from "mersenne.c" */
extern  void  jvrand_set_seed2 (unsigned long init_key[], int key_length);
extern  unsigned long  jvrand_int32 (void);

static inline long int
jvrand_int31 (void)
{
  return (jvrand_int32()>>1);
}

static inline double
jvrand_real2 (void)
/* generates a random number on [0,1)-real-interval */
{
  return  jvrand_int32() * (1.0 / 4294967296.0); /* divided by 2^32 */
}

/* from "error.c" */
extern  void  jvrand_error (const char *msg)  NORETURN_FN;

#endif /* FILE_JVRAND_P_H_SEEN */
