/* poisson.c - the Poisson distribution
 *
 * Copyright (C) 2001  Jochen Voss.  */

static const  char  rcsid[] = "$Id: poisson.c 6503 2005-07-05 22:33:38Z voss $";

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <math.h>
#include <assert.h>

#include "jvrand-p.h"


unsigned
jvrand_poisson (double m)
{
  double  x, limit;
  unsigned  res;
  
  assert (m >= 0);

  limit = exp (-m);
  x = 1;
  res = 0;
  for (;;) {
    x *= jvrand_real2 ();
    if (x < limit)  return  res;
    ++res;
  }
}
