/* shuffle.c - randomly reorder an array
 *
 * Copyright (C) 2001  Jochen Voss.  */

static const  char  rcsid[] = "$Id: shuffle.c 5876 2004-08-14 10:36:54Z voss $";

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdlib.h>
#include <string.h>

#include "jvrand-p.h"


void
jvrand_shuffle (void *base, size_t count, size_t size)
{
  char *buffer;
  size_t  j;

  if (count == 0 || size == 0)  return;
  buffer = malloc (size);
  if (! buffer)  jvrand_error ("out of memory");
  for (j=count-1; j>0; --j) {
    size_t  k = jvrand_discrete (0, j+1);
    if (j != k) {
      memcpy (buffer, base+j*size, size);
      memcpy (base+j*size, base+k*size, size);
      memcpy (base+k*size, buffer, size);
    }
  }
  free (buffer);
}
