/* table.c - generate tables for algorithm F of Knuth, p. 124
 *
 * This is an auxiliary program to generate the table in
 * file "normal.c".
 *
 * Copyright (C) 2001  Jochen Voss.  */

static const  char  rcsid[] = "$Id: table.c 5876 2004-08-14 10:36:54Z voss $";

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdio.h>
#include <math.h>
#include <float.h>
#include <assert.h>


#define  PARAM_T  30


static long double
f (long double x)
{
  return  1-erfl (x*M_SQRT1_2);
}

static long double
a (int j)
{
  long double  y, l, r;
  int  i, done;

  y = 1;
  for (i=0; i<j; ++i)  y *= 0.5;

  l = 0;
  r = 0.1;
  while (f(r)>=y)  r+=0.1;

  done = 0;
  while (! done) {
    long double  m;
    assert (f(l) >= y && y > f(r));
    m = 0.5*(l+r);
    if (m == l || m == r)  done = 1;
    if (f(m) >= y) {
      l = m;
    } else {
      r = m;
    }
  }
  return  l;
}

int
main ()
{
  int  j;

  printf ("static double param_d [%d] = {\n", PARAM_T+2);
  puts ("  -1,");
  for (j=1; j<=PARAM_T+1; ++j) {
    printf ("  %.20Lf,\n", a(j)-a(j-1));
  }
  puts ("};");
  return  0;
}
