/* test-discrete.c - test the 'jvrand_discrete' function
 *
 * Copyright (C) 2001  Jochen Voss.  */

static const  char  rcsid[] = "$Id: test-discrete.c 5378 2003-10-29 12:01:05Z voss $";

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdlib.h>
#include <limits.h>

#include "jvrand.h"
#include "util.h"


static int
test1 (void *client_data)
{
  int  x = jvrand_discrete (INT_MIN, INT_MAX);
  return  (x < 0);
}

static int
test2 (void *client_data)
{
  int  x = jvrand_discrete (-2, 999998);
  return  (x < 399998);
}

static int
test3 (void *client_data)
{
  int  x = jvrand_discrete (0, 2);
  return  (x == 0);
}

static int
test4 (void *client_data)
{
  int  x = jvrand_discrete (1000, 1100);
  return  (x%2);
}


int
main (int argc, char **argv)
{
  int  fail = 0;

  init_util (argc, argv);
  jvrand_init ();

  binomial_test (test1, NULL, 0.5, 0.001, "large ranges", &fail);
  binomial_test (test2, NULL, 0.4, 0.001, "medium ranges", &fail);
  binomial_test (test3, NULL, 0.5, 0.001, "small ranges", &fail);
  binomial_test (test4, NULL, 0.5, 0.0005, "odd numbers", &fail);

  return  fail;
}
