/* test-geometric.c - test the the geometric distribution
 *
 * Copyright (C) 2001  Jochen Voss.  */

static const  char  rcsid[] = "$Id: test-geometric.c 5876 2004-08-14 10:36:54Z voss $";

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdlib.h>
#include <math.h>

#include "jvrand.h"
#include "util.h"


static int
test1 (void *client_data)
{
  return  (jvrand_geometric (2.0/9) == 0);
}

static int
test2 (void *client_data)
{
  return  (jvrand_geometric (1.0/3) == 1);
}

static int
test3 (void *client_data)
{
  return  (jvrand_geometric (0.1) >= 10);
}

static int
test4 (void *client_data)
{
  return  (jvrand_geometric (0.1) >= 20);
}

static int
test5 (void *client_data)
{
  return  (jvrand_geometric (0.1) >= 30);
}


int
main (int argc, char **argv)
{
  int  fail = 0;
  double  p;

  init_util (argc, argv);
  jvrand_init ();

  binomial_test (test1, NULL, 2.0/9, 0.001, "P(X=0)", &fail);
  binomial_test (test2, NULL, 2.0/9, 0.001, "P(X=1)", &fail);
  p = pow (0.9, 10);
  binomial_test (test3, NULL, p, 0.001, "P(X>=10)", &fail);
  p = pow (0.9, 20);
  binomial_test (test4, NULL, p, 0.0005, "P(X>=20)", &fail);
  p = pow (0.9, 30);
  binomial_test (test5, NULL, p, 0.0003, "P(X>=30)", &fail);

  return  fail;
}
