/* test-normal.c - test the normal distribution
 *
 * Copyright (C) 2001  Jochen Voss.  */

static const  char  rcsid[] = "$Id: test-normal.c 5876 2004-08-14 10:36:54Z voss $";

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdlib.h>

#include "jvrand.h"
#include "util.h"


static double
test1 (void *client_data)
{
  return  jvrand_normal (-1, 2);
}

static int
test2 (void *client_data)
{
  return  (jvrand_normal (-1, 2) >= 0);
}

static int
test3 (void *client_data)
{
  return  (jvrand_normal (-1, 2) >= 2);
}

static double
test4 (void *client_data)
{
  return  jvrand_normal (703, 1.2) - jvrand_normal (700, 2.8);
}

static int
test5 (void *client_data)
{
  return  (jvrand_normal (703, 1.2) - jvrand_normal (700, 2.8) <= 2);
}


int
main (int argc, char **argv)
{
  int  fail = 0;

  init_util (argc, argv);
  jvrand_init ();
  
  normal_test (test1, NULL, -1, 0.005, 2, "mean of N(-1,2)", &fail);
  binomial_test (test2, NULL, 0.2397500611, 0.0005, "variance of N(-1,2)", &fail);
  binomial_test (test3, NULL, 0.0169474268, 0.0005, "tails of N(-1,2)",
		 &fail);
  normal_test (test4, NULL, 3, 0.005, 4, "mean of pair differences", &fail);
  binomial_test (test5, NULL, 0.3085375387, 0.001, "variance of pair differences",
		 &fail);
  
  return  fail;
}
