/* test-poisson.c - statistical tests for the poisson distribution
 *
 * Copyright (C) 2001  Jochen Voss.  */

static const  char  rcsid[] = "$Id: test-poisson.c 5876 2004-08-14 10:36:54Z voss $";

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdlib.h>
#include <math.h>

#include "jvrand.h"
#include "util.h"


static int
test1 (void *client_data)
{
  return  (jvrand_poisson (2) == 0);
}

static int
test2 (void *client_data)
{
  return  (jvrand_poisson (2) == 1);
}

static int
test3 (void *client_data)
{
  return  (jvrand_poisson (2) >= 5);
}

int
main (int argc, char **argv)
{
  int  fail = 0;
  double  p;

  init_util (argc, argv);
  jvrand_init ();

  binomial_test (test1, NULL, exp(-2), 0.001, "P(X=0)", &fail);
  binomial_test (test2, NULL, 2*exp(-2), 0.001, "P(X=1)", &fail);

  p = 1 - exp(-2)*(1+2+4/2.0+8/6.0+16/24.0);
  binomial_test (test3, NULL, p, 0.001, "P(X>=5)", &fail);
  
  return  fail;
}
