/* timer.c - measure the speed of random number generation
 *
 * Copyright (C) 2001  Jochen Voss.  */

static const  char  rcsid[] = "$Id: timer.c 5876 2004-08-14 10:36:54Z voss $";

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <setjmp.h>
#include <sys/time.h>

#include "jvrand.h"


static  sigjmp_buf  leave_loop;

static void
handle_alarm (int signum)
{
  siglongjmp (leave_loop, 1);
}

static unsigned long
count (void)
{
  volatile  unsigned long  n = 0;
  struct itimerval  pause;
  
  pause.it_interval.tv_usec = 0;
  pause.it_interval.tv_sec = 0;
  pause.it_value.tv_usec = 0;
  pause.it_value.tv_sec = 1;

  signal (SIGVTALRM, handle_alarm);
  if (sigsetjmp (leave_loop, 1) == 0) {
    if (setitimer (ITIMER_VIRTUAL, &pause, NULL) < 0)  abort ();
    while (1) {
      jvrand_normal (0, 1);
      ++n;
    }
  }

  return  n;
}

int
main ()
{
  int  i;

  jvrand_init ();
  
  puts ("testing jvrand_normal:");
  count ();
  for (i=0; i<10; ++i) {
    printf ("  %lu\n", count ());
  } 
  return  0;
}
